Attribute VB_Name = "DrawArrow"
Option Explicit

Private Type POINTAPI
    x As Long
    y As Long
End Type

Private Declare Function BeginPath Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function FillPath Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function StrokeAndFillPath Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function StrokePath Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function EndPath Lib "gdi32" (ByVal hdc As Long) As Long

Private Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

Private Declare Function CloseFigure Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function Polyline Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long


Private Sub TraceArrow(hdc As Long, PtX As Integer, PtY As Integer, ByVal PtAngle As Single, ByVal ArAngle As Single, PtLenght As Integer, BLenght As Integer, BWidth As Integer, Optional OutlineColor As Long = 0, Optional FillColor As Long = 0, Optional Outlined As Boolean = True, Optional Filled As Boolean = False)
    Dim Pi As Single
    
    Dim PolyPoints(6) As POINTAPI
    
    Dim L1 As Integer
    
    Dim hPen As Long, hOldPen As Long, hBr As Long, hOldBr As Long
    
    hPen = CreatePen(0, 1, OutlineColor)
    hOldPen = SelectObject(hdc, hPen)
    hBr = CreateSolidBrush(FillColor)
    hOldBr = SelectObject(hdc, hBr)
    
    PolyPoints(0).x = PtX
    PolyPoints(0).y = PtY
    
    Pi = 4 * Atn(1)
    
    PtAngle = deg2rad(PtAngle / 2)
    ArAngle = -deg2rad(ArAngle)
    
    PolyPoints(1).x = Cos(ArAngle - PtAngle) * PtLenght + PtX
    PolyPoints(1).y = Sin(ArAngle - PtAngle) * PtLenght + PtY
    
    PolyPoints(6).x = Cos(ArAngle + PtAngle) * PtLenght + PtX
    PolyPoints(6).y = Sin(ArAngle + PtAngle) * PtLenght + PtY
    
    L1 = (Sqr((PolyPoints(1).x - PolyPoints(6).x) ^ 2 + (PolyPoints(1).y - PolyPoints(6).y) ^ 2) - BWidth) / 2
    
    PolyPoints(2).x = Cos(Pi / 2 + ArAngle) * L1
    PolyPoints(2).y = Sin(Pi / 2 + ArAngle) * L1
    
    PolyPoints(5).x = PolyPoints(6).x - PolyPoints(2).x
    PolyPoints(5).y = PolyPoints(6).y - PolyPoints(2).y
    PolyPoints(2).x = PolyPoints(1).x + PolyPoints(2).x
    PolyPoints(2).y = PolyPoints(1).y + PolyPoints(2).y
    
    PolyPoints(3).x = Cos(ArAngle) * BLenght
    PolyPoints(3).y = Sin(ArAngle) * BLenght
    
    PolyPoints(4).x = PolyPoints(5).x + PolyPoints(3).x
    PolyPoints(4).y = PolyPoints(5).y + PolyPoints(3).y
    PolyPoints(3).x = PolyPoints(2).x + PolyPoints(3).x
    PolyPoints(3).y = PolyPoints(2).y + PolyPoints(3).y
    
    BeginPath hdc
    
        Polyline hdc, PolyPoints(0), 7
        CloseFigure hdc
    
    EndPath hdc
    
    If Outlined And Filled Then
        StrokeAndFillPath hdc
    ElseIf Outlined Then
        StrokePath hdc
    ElseIf Filled Then
        FillPath hdc
    End If
    
    SelectObject hdc, hOldPen
    SelectObject hdc, hOldBr
    DeleteObject hPen
    DeleteObject hBr
End Sub
